diff -ru --new-file a/gas/config/tc-sh.c b/gas/config/tc-sh.c
--- a/gas/config/tc-sh.c	2013-11-04 19:33:37.000000000 +0400
+++ b/gas/config/tc-sh.c	2022-02-17 13:31:43.959249000 +0300
@@ -803,7 +803,7 @@
       r_type = BFD_RELOC_UNUSED;
     }
 
-  fix_new_exp (frag, off, size, exp, 0, r_type);
+  fix_new_exp (frag, off, size, exp, 0, r_type,0);
 }
 
 /* The regular cons() function, that reads constants, doesn't support
@@ -2243,7 +2243,7 @@
 	       2,
 	       &op->immediate,
 	       pcrel,
-	       how);
+	       how,0);
 }
 
 static void
@@ -2254,7 +2254,7 @@
 	       4,
 	       & op->immediate,
 	       pcrel,
-	       how);
+	       how,0);
 }
 static void
 build_relax (sh_opcode_info *opcode, sh_operand_info *op)
@@ -2324,7 +2324,7 @@
       symbol_table_insert (end_sym);
       end_sym->sy_value = operand[1].immediate;
       end_sym->sy_value.X_add_number += 2;
-      fix_new (frag_now, frag_now_fix (), 2, end_sym, 0, 1, BFD_RELOC_SH_LABEL);
+      fix_new (frag_now, frag_now_fix (), 2, end_sym, 0, 1, BFD_RELOC_SH_LABEL,0);
     }
 
   output = frag_more (2);
@@ -2978,7 +2978,7 @@
       /* Output a CODE reloc to tell the linker that the following
          bytes are instructions, not data.  */
       fix_new (frag_now, frag_now_fix (), 2, &abs_symbol, 0, 0,
-	       BFD_RELOC_SH_CODE);
+	       BFD_RELOC_SH_CODE,0);
       seg_info (now_seg)->tc_segment_info_data.in_code = 1;
     }
 
@@ -3059,7 +3059,7 @@
       if (frag_now != last_label_frag
 	  || offset != last_label_offset)
 	{
-	  fix_new (frag_now, offset, 2, &abs_symbol, 0, 0, BFD_RELOC_SH_LABEL);
+	  fix_new (frag_now, offset, 2, &abs_symbol, 0, 0, BFD_RELOC_SH_LABEL,0);
 	  last_label_frag = frag_now;
 	  last_label_offset = offset;
 	}
@@ -3078,7 +3078,7 @@
       && seg_info (now_seg)->tc_segment_info_data.in_code)
     {
       fix_new (frag_now, frag_now_fix (), 2, &abs_symbol, 0, 0,
-	       BFD_RELOC_SH_DATA);
+	       BFD_RELOC_SH_DATA,0);
       seg_info (now_seg)->tc_segment_info_data.in_code = 0;
     }
 }
@@ -3119,7 +3119,7 @@
       return;
     }
 
-  fix_new_exp (frag_now, frag_now_fix (), 2, &ex, 1, BFD_RELOC_SH_USES);
+  fix_new_exp (frag_now, frag_now_fix (), 2, &ex, 1, BFD_RELOC_SH_USES,0);
 
   demand_empty_rest_of_line ();
 }
@@ -3518,7 +3518,7 @@
       subseg_change (sec, 0);
       fix_new (fscan->fx_frag,
 	       S_GET_VALUE (sym) - fscan->fx_frag->fr_address,
-	       4, &abs_symbol, info.count, 0, BFD_RELOC_SH_COUNT);
+	       4, &abs_symbol, info.count, 0, BFD_RELOC_SH_COUNT,0);
     }
 }
 
@@ -3559,7 +3559,7 @@
     case C (COND_JUMP_DELAY, COND8):
       subseg_change (seg, 0);
       fix_new (fragP, fragP->fr_fix, 2, fragP->fr_symbol, fragP->fr_offset,
-	       1, BFD_RELOC_SH_PCDISP8BY2);
+	       1, BFD_RELOC_SH_PCDISP8BY2,0);
       fragP->fr_fix += 2;
       fragP->fr_var = 0;
       break;
@@ -3567,7 +3567,7 @@
     case C (UNCOND_JUMP, UNCOND12):
       subseg_change (seg, 0);
       fix_new (fragP, fragP->fr_fix, 2, fragP->fr_symbol, fragP->fr_offset,
-	       1, BFD_RELOC_SH_PCDISP12BY2);
+	       1, BFD_RELOC_SH_PCDISP12BY2,0);
       fragP->fr_fix += 2;
       fragP->fr_var = 0;
       break;
@@ -3624,13 +3624,13 @@
 	subseg_change (seg, 0);
 	fix_new (fragP, fragP->fr_fix, 2, section_symbol (seg),
 		 fragP->fr_address + fragP->fr_fix + (delay ? 4 : 6),
-		 1, BFD_RELOC_SH_PCDISP8BY2);
+		 1, BFD_RELOC_SH_PCDISP8BY2,0);
 
 	/* Set up a jump instruction.  */
 	buffer[highbyte + 2] = 0xa0;
 	buffer[lowbyte + 2] = 0;
 	fix_new (fragP, fragP->fr_fix + 2, 2, fragP->fr_symbol,
-		 fragP->fr_offset, 1, BFD_RELOC_SH_PCDISP12BY2);
+		 fragP->fr_offset, 1, BFD_RELOC_SH_PCDISP12BY2,0);
 
 	if (delay)
 	  {
@@ -3802,7 +3802,7 @@
       && frag->fr_offset > 1
       && now_seg != bss_section)
     fix_new (frag, frag->fr_fix, 2, &abs_symbol, frag->fr_offset, 0,
-	     BFD_RELOC_SH_ALIGN);
+	     BFD_RELOC_SH_ALIGN,0);
 }
 
 /* See whether the relocation should be resolved locally.  */
diff -ru --new-file a/gas/config/te-amiga.h b/gas/config/te-amiga.h
--- a/gas/config/te-amiga.h	1970-01-01 03:00:00.000000000 +0300
+++ b/gas/config/te-amiga.h	2021-02-01 23:12:49.208608700 +0300
@@ -0,0 +1,24 @@
+/*
+ * te-amiga.h -- Amiga target environment declarations.
+ */
+
+#define TE_AMIGA 1
+
+#define LOCAL_LABELS_DOLLAR 1
+#define LOCAL_LABELS_FB 1
+
+#ifdef OBJ_HEADER
+#include OBJ_HEADER
+#else
+#include "obj-format.h"
+#endif
+
+#define TC_IMPLICIT_LCOMM_ALIGNMENT(SIZE, P2VAR)	\
+  do {							\
+    if ((SIZE) >= 4)                                 	\
+      (P2VAR) = 2;					\
+    else if ((SIZE) >= 2)				\
+      (P2VAR) = 1;					\
+    else						\
+      (P2VAR) = 0;					\
+  } while (0)
diff -ru --new-file a/gas/config/te-amigaos.h b/gas/config/te-amigaos.h
--- a/gas/config/te-amigaos.h	1970-01-01 03:00:00.000000000 +0300
+++ b/gas/config/te-amigaos.h	2021-02-01 23:12:49.209611100 +0300
@@ -0,0 +1,14 @@
+/*
+ * te-amigaos.h -- Amiga target environment declarations.
+ */
+
+#define TE_AMIGAOS 1
+
+#define LOCAL_LABELS_DOLLAR 1
+#define LOCAL_LABELS_FB 1
+
+#ifdef OBJ_HEADER
+#include OBJ_HEADER
+#else
+#include "obj-format.h"
+#endif
diff -ru --new-file a/gas/config/te-amithlon.h b/gas/config/te-amithlon.h
--- a/gas/config/te-amithlon.h	1970-01-01 03:00:00.000000000 +0300
+++ b/gas/config/te-amithlon.h	2021-02-01 23:12:49.210613600 +0300
@@ -0,0 +1,26 @@
+/* te-amithlon.h -- Amithlon target environment declarations.
+   Copyright 2000 Free Software Foundation, Inc.
+
+   This file is part of GAS, the GNU Assembler.
+
+   GAS is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   GAS is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with GAS; see the file COPYING.  If not, write to the Free
+   Software Foundation, 59 Temple Place - Suite 330, Boston, MA
+   02111-1307, USA.  */
+
+#define TE_Amithlon 1
+
+#define LOCAL_LABELS_DOLLAR 1
+#define LOCAL_LABELS_FB 1
+
+#include "obj-format.h"
diff -ru --new-file a/gas/config/te-morphos.h b/gas/config/te-morphos.h
--- a/gas/config/te-morphos.h	1970-01-01 03:00:00.000000000 +0300
+++ b/gas/config/te-morphos.h	2021-02-01 23:12:49.211616100 +0300
@@ -0,0 +1,14 @@
+/*
+ * te-amiga.h -- Amiga target environment declarations.
+ */
+
+#define TE_MORPHOS 1
+
+#define LOCAL_LABELS_DOLLAR 1
+#define LOCAL_LABELS_FB 1
+
+#ifdef OBJ_HEADER
+#include OBJ_HEADER
+#else
+#include "obj-format.h"
+#endif
diff -ru --new-file a/gas/configure.in b/gas/configure.in
--- a/gas/configure.in	2013-11-04 19:33:37.000000000 +0400
+++ b/gas/configure.in	2022-02-17 13:35:06.040695100 +0300
@@ -594,6 +594,14 @@
 AC_DEFINE_UNQUOTED(DEFAULT_EMULATION, "$DEFAULT_EMULATION",
 		   [Default emulation.])
 
+# FIXME: As of version 2.18 of binutils, MANY_SEGMENTS no longer exists
+#case ${primary_bfd_gas}-${target_cpu_type}-${obj_format} in
+#  yes-*-coff)	need_bfd=yes ;;
+#  no-*-coff | yes-m68k-amigahunk | no-m68k-amigahunk)	need_bfd=yes
+#		AC_DEFINE(MANY_SEGMENTS, 1, [old COFF support?]) ;;
+#esac
+
+
 reject_dev_configs=yes
 
 case ${reject_dev_configs}-${dev} in
@@ -624,6 +632,17 @@
 AC_DEFINE_UNQUOTED(TARGET_VENDOR,	"${target_vendor}", [Target vendor.])
 AC_DEFINE_UNQUOTED(TARGET_OS,		"${target_os}",    [Target OS.])
 
+### begin-GG-local
+# Check for additional host specific CFLAGS.
+AC_MSG_CHECKING(for host dependent CFLAGS)
+other_host_cflags=""
+case "${host}" in
+	m68k-*-amigaos*)	other_host_cflags="-mstackextend" ;;
+esac
+test -n "$other_host_cflags" && CFLAGS="$CFLAGS $other_host_cflags"
+AC_MSG_RESULT($other_host_cflags)
+### end-GG-local
+
 AC_PROG_YACC
 AM_PROG_LEX
 
diff -ru --new-file a/gas/configure.tgt b/gas/configure.tgt
--- a/gas/configure.tgt	2013-11-04 19:33:37.000000000 +0400
+++ b/gas/configure.tgt	2022-02-17 13:36:24.744812500 +0300
@@ -60,7 +60,8 @@
   epiphany*)		cpu_type=epiphany endian=little ;;
   fido)			cpu_type=m68k ;;
   hppa*)		cpu_type=hppa ;;
-  i[3-7]86)		cpu_type=i386 arch=i386;;
+  i[3-7]86)		cpu_type=i386 arch=i386 endian=little ;;
+  i[3-7]86)		cpu_type=i386 arch=i386 endian=big ;;
   ia64)			cpu_type=ia64 ;;
   ip2k)			cpu_type=ip2k endian=big ;;
   iq2000)		cpu_type=iq2000 endian=big ;;
@@ -202,6 +203,7 @@
 
   i386-ibm-aix*)			fmt=coff em=i386aix ;;
   i386-sequent-bsd*)			fmt=aout em=dynix ;;
+  i386-*-amithlon*)	    		fmt=elf em=amithlon ;;
   i386-*-beospe*)			fmt=coff em=pe ;;
   i386-*-beos*)				fmt=elf ;;
   i386-*-coff)				fmt=coff ;;
@@ -296,6 +298,8 @@
   m68hc11-*-* | m6811-*-*)		fmt=elf ;;
   m68hc12-*-* | m6812-*-*)		fmt=elf ;;
 
+  m68k-*-amigaoshunk)		fmt=amigahunk em=amiga bfd_gas=yes ;;
+  m68k-*-amigaos*)			fmt=aout em=amiga ;;
   m68k-*-aout)				fmt=aout bfd_gas=yes ;;
   m68k-*-elf*)				fmt=elf ;;
   m68k-*-sysv4*)			fmt=elf em=svr4 ;;
@@ -359,6 +363,8 @@
 
   pj*)					fmt=elf ;;
 
+  ppc-*-amigaos*)         		fmt=elf em=amigaos ;;
+  ppc-*-morphos*)			fmt=elf em=morphos ;;
   ppc-*-pe | ppc-*-cygwin*)		fmt=coff em=pe ;;
   ppc-*-winnt*)				fmt=coff em=pe ;;
   ppc-*-aix5.[01])			fmt=coff em=aix5 ;;
diff -ru --new-file a/gas/Makefile.am b/gas/Makefile.am
--- a/gas/Makefile.am	2013-11-04 19:33:37.000000000 +0400
+++ b/gas/Makefile.am	2022-02-16 23:38:43.495889000 +0300
@@ -269,6 +269,7 @@
 # OBJ files in config
 
 OBJ_FORMAT_CFILES = \
+	config/obj-amigahunk.c \
 	config/obj-aout.c \
 	config/obj-coff.c \
 	config/obj-ecoff.c \
@@ -280,6 +281,7 @@
 	config/obj-som.c
 
 OBJ_FORMAT_HFILES = \
+	config/obj-amigahunk.h \
 	config/obj-aout.h \
 	config/obj-coff.h \
 	config/obj-ecoff.h \
@@ -295,6 +297,7 @@
 TARG_ENV_HFILES = \
 	config/te-386bsd.h \
 	config/te-aix5.h \
+	config/te-amiga.h \
 	config/te-armeabi.h \
 	config/te-armlinuxeabi.h \
 	config/te-dynix.h \
@@ -364,7 +367,7 @@
 	rl78-parse.c rl78-parse.h \
 	rx-parse.c rx-parse.h
 
-diststuff: $(EXTRA_DIST) info
+diststuff: $(EXTRA_DIST) info guide
 
 DISTCLEANFILES = targ-cpu.h obj-format.h targ-env.h itbl-cpu.h cgen-desc.h
 
diff -ru --new-file a/gas/read.h b/gas/read.h
--- a/gas/read.h	2013-11-04 19:33:37.000000000 +0400
+++ b/gas/read.h	2022-02-17 13:39:03.489963500 +0300
@@ -133,6 +133,10 @@
 
 extern void generate_lineno_debug (void);
 
+#ifdef OBJ_AMIGAHUNK
+extern void s_data_chip (int);
+#endif
+
 extern void s_abort (int) ATTRIBUTE_NORETURN;
 extern void s_align_bytes (int arg);
 extern void s_align_ptwo (int);
diff -ru --new-file a/gas/write.c b/gas/write.c
--- a/gas/write.c	2013-11-04 19:33:38.000000000 +0400
+++ b/gas/write.c	2022-02-17 13:43:17.712899000 +0300
@@ -151,7 +151,8 @@
 		  offsetT offset,	/* X_add_number.  */
 		  int pcrel,		/* TRUE if PC-relative relocation.  */
 		  RELOC_ENUM r_type	/* Relocation type.  */,
-		  int at_beginning)	/* Add to the start of the list?  */
+		  int at_beginning,	/* Add to the start of the list?  */
+		  int baserel ATTRIBUTE_UNUSED) /* TRUE if base-relative data */
 {
   fixS *fixP;
 
@@ -191,8 +192,11 @@
 #endif
 
 #ifdef TC_FIX_TYPE
+#ifndef TC_PPC
+  fixP->tc_fix_data = baserel;
   TC_INIT_FIX_DATA (fixP);
 #endif
+#endif
 
   as_where (&fixP->fx_file, &fixP->fx_line);
 
@@ -235,10 +239,11 @@
 	 symbolS *add_symbol,	/* X_add_symbol.  */
 	 offsetT offset,		/* X_add_number.  */
 	 int pcrel,			/* TRUE if PC-relative relocation.  */
-	 RELOC_ENUM r_type		/* Relocation type.  */)
+	 RELOC_ENUM r_type,		/* Relocation type.  */
+     int baserel)		/* TRUE if base-relative data */
 {
   return fix_new_internal (frag, where, size, add_symbol,
-			   (symbolS *) NULL, offset, pcrel, r_type, FALSE);
+			   (symbolS *) NULL, offset, pcrel, r_type, FALSE,baserel);
 }
 
 /* Create a fixup for an expression.  Currently we only support fixups
@@ -251,7 +256,8 @@
 	     int size,			/* 1, 2, or 4 usually.  */
 	     expressionS *exp,		/* Expression.  */
 	     int pcrel,			/* TRUE if PC-relative relocation.  */
-	     RELOC_ENUM r_type		/* Relocation type.  */)
+	     RELOC_ENUM r_type,		/* Relocation type.  */
+	     int baserel)		/* TRUE if base-relative data */
 {
   symbolS *add = NULL;
   symbolS *sub = NULL;
@@ -277,7 +283,7 @@
 	exp->X_add_symbol = stmp;
 	exp->X_add_number = 0;
 
-	return fix_new_exp (frag, where, size, exp, pcrel, r_type);
+	return fix_new_exp (frag, where, size, exp, pcrel, r_type,baserel);
       }
 
     case O_symbol_rva:
@@ -307,7 +313,7 @@
     }
 
   return fix_new_internal (frag, where, size, add, sub, off, pcrel,
-			   r_type, FALSE);
+			   r_type, FALSE,baserel);
 }
 
 /* Create a fixup at the beginning of FRAG.  The arguments are the same
@@ -318,7 +324,7 @@
 	      offsetT offset, int pcrel, RELOC_ENUM r_type)
 {
   return fix_new_internal (frag, 0, size, add_symbol,
-			   (symbolS *) NULL, offset, pcrel, r_type, TRUE);
+			   (symbolS *) NULL, offset, pcrel, r_type, TRUE,0);
 }
 
 /* Generic function to determine whether a fixup requires a relocation.  */
@@ -894,6 +900,13 @@
    Ones that we couldn't completely handle here will be output later
    by emit_relocations.  */
 
+/* FIXME: There was following code here
+#if !defined(BFD_ASSEMBLER) && !defined(MANY_SEGMENTS)
+      if (fixP->tc_fix_data && add_number != fixP->fx_offset)
+        add_number -= text_last_frag->fr_address;
+#endif
+*/
+
 static void
 fixup_segment (fixS *fixP, segT this_segment)
 {
@@ -1885,11 +1898,11 @@
 #ifdef TC_CONS_FIX_NEW
 	  TC_CONS_FIX_NEW (lie->frag,
 			   lie->word_goes_here - lie->frag->fr_literal,
-			   2, &exp);
+			   2, &exp,0);
 #else
 	  fix_new_exp (lie->frag,
 		       lie->word_goes_here - lie->frag->fr_literal,
-		       2, &exp, 0, BFD_RELOC_16);
+		       2, &exp, 0, BFD_RELOC_16,0);
 #endif
 	  *prevP = lie->next_broken_word;
 	}
diff -ru --new-file a/gas/write.h b/gas/write.h
--- a/gas/write.h	2013-11-04 19:33:38.000000000 +0400
+++ b/gas/write.h	2022-02-17 13:45:10.200969500 +0300
@@ -179,13 +179,13 @@
 extern void number_to_chars_bigendian (char *, valueT, int);
 extern fixS *fix_new
   (fragS * frag, int where, int size, symbolS * add_symbol,
-   offsetT offset, int pcrel, bfd_reloc_code_real_type r_type);
+   offsetT offset, int pcrel, bfd_reloc_code_real_type r_type,int baserel);
 extern fixS *fix_at_start
   (fragS * frag, int size, symbolS * add_symbol,
    offsetT offset, int pcrel, bfd_reloc_code_real_type r_type);
 extern fixS *fix_new_exp
   (fragS * frag, int where, int size, expressionS *exp, int pcrel,
-   bfd_reloc_code_real_type r_type);
+   bfd_reloc_code_real_type r_type,int baserel);
 extern void write_print_statistics (FILE *);
 
 #endif /* __write_h__ */
diff -ru --new-file a/gprof/configure.in b/gprof/configure.in
--- a/gprof/configure.in	2013-11-04 19:33:39.000000000 +0400
+++ b/gprof/configure.in	2022-02-17 13:47:02.720239900 +0300
@@ -48,6 +48,17 @@
 ZW_GNU_GETTEXT_SISTER_DIR
 AM_PO_SUBDIRS
 
+### begin-GG-local
+# Check for additional host specific CFLAGS.
+AC_MSG_CHECKING(for host dependent CFLAGS)
+other_host_cflags=""
+case "${host}" in
+	m68*-*-amigaos*)	other_host_cflags="-mstackextend" ;;
+esac
+test -n "$other_host_cflags" && CFLAGS="$CFLAGS $other_host_cflags"
+AC_MSG_RESULT($other_host_cflags)
+### end-GG-local
+
 AM_MAINTAINER_MODE
 AM_CONDITIONAL(GENINSRC_NEVER, false)
 AC_EXEEXT
diff -ru --new-file a/gprof/gconfig.in b/gprof/gconfig.in
--- a/gprof/gconfig.in	2013-11-04 19:33:39.000000000 +0400
+++ b/gprof/gconfig.in	2022-02-17 13:47:29.161449300 +0300
@@ -1,9 +1,5 @@
 /* gconfig.in.  Generated from configure.in by autoheader.  */
 
-/* Define to 1 if translation of program messages to the user's native
-   language is requested. */
-#undef ENABLE_NLS
-
 /* Is the prototype for getopt in <unistd.h> in the expected format? */
 #undef HAVE_DECL_GETOPT
 
diff -ru --new-file a/gprof/Makefile.am b/gprof/Makefile.am
--- a/gprof/Makefile.am	2013-11-08 14:13:48.000000000 +0400
+++ b/gprof/Makefile.am	2022-02-17 13:45:40.712347000 +0300
@@ -56,7 +56,7 @@
 BUILT_SOURCES = flat_bl.c bsd_callg_bl.c fsf_callg_bl.c
 EXTRA_DIST    = $(BUILT_SOURCES) bbconv.pl $(man_MANS)
 
-diststuff: $(BUILT_SOURCES) info $(man_MANS)
+diststuff: $(BUILT_SOURCES) info guide $(man_MANS)
 
 # We extract version from bfd/configure.in, make sure to rerun configure
 # when BFD's version changes.
diff -ru --new-file a/include/elf/amigaos.h b/include/elf/amigaos.h
--- a/include/elf/amigaos.h	1970-01-01 03:00:00.000000000 +0300
+++ b/include/elf/amigaos.h	2021-02-01 23:12:49.248749300 +0300
@@ -0,0 +1,27 @@
+/* AmigaOS ELF support for BFD.
+   Copyright 2001 Free Software Foundation, Inc.
+
+This file is part of BFD, the Binary File Descriptor library.
+
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software Foundation, Inc.,
+51 Franklin Street - Fifth Floor, Boston, MA 02110-1301, USA.  */
+
+#ifndef _ELF_AMIGAOS_H
+#define _ELF_AMIGAOS_H
+
+#include "elf/common.h"
+
+#define DT_AMIGAOS_DYNVERSION	(DT_LOOS + 1)
+
+#endif /* _ELF_AMIGAOS_H */
diff -ru --new-file a/include/elf/ppc.h b/include/elf/ppc.h
--- a/include/elf/ppc.h	2013-11-18 12:40:15.000000000 +0400
+++ b/include/elf/ppc.h	2022-02-17 13:49:00.297572500 +0300
@@ -131,6 +131,19 @@
   RELOC_NUMBER (R_PPC_EMB_BIT_FLD,	115)
   RELOC_NUMBER (R_PPC_EMB_RELSDA,	116)
 
+/* Special MorphOS relocs. */
+  RELOC_NUMBER (R_PPC_MORPHOS_DREL,	200)
+  RELOC_NUMBER (R_PPC_MORPHOS_DREL_LO,	201)
+  RELOC_NUMBER (R_PPC_MORPHOS_DREL_HI,	202)
+  RELOC_NUMBER (R_PPC_MORPHOS_DREL_HA,	203)
+
+/* AmigaOS4 relocs */
+  RELOC_NUMBER (R_PPC_AMIGAOS_BREL,	210)
+  RELOC_NUMBER (R_PPC_AMIGAOS_BREL_LO,	211)
+  RELOC_NUMBER (R_PPC_AMIGAOS_BREL_HI,  212)
+  RELOC_NUMBER (R_PPC_AMIGAOS_BREL_HA,  213)
+
+
 /* PowerPC VLE relocations.  */
   RELOC_NUMBER (R_PPC_VLE_REL8,		216)
   RELOC_NUMBER (R_PPC_VLE_REL15,	217)
diff -ru --new-file a/include/libiberty.h b/include/libiberty.h
--- a/include/libiberty.h	2013-11-04 19:33:39.000000000 +0400
+++ b/include/libiberty.h	2022-02-17 13:49:42.536175300 +0300
@@ -106,7 +106,7 @@
    to find the declaration so provide a fully prototyped one.  If it
    is 1, we found it so don't provide any declaration at all.  */
 #if !HAVE_DECL_BASENAME
-#if defined (__GNU_LIBRARY__ ) || defined (__linux__) || defined (__FreeBSD__) || defined (__OpenBSD__) || defined(__NetBSD__) || defined (__CYGWIN__) || defined (__CYGWIN32__) || defined (__MINGW32__) || defined (HAVE_DECL_BASENAME)
+#if defined (__GNU_LIBRARY__ ) || defined (__linux__) || defined (__FreeBSD__) || defined (__OpenBSD__) || defined(__NetBSD__) || defined (__CYGWIN__) || defined (__CYGWIN32__) || defined (__MINGW32__) || defined(AMIGA) || defined (HAVE_DECL_BASENAME)
 extern char *basename (const char *);
 #else
 /* Do not allow basename to be used if there is no prototype seen.  We
diff -ru --new-file a/ld/configure.host b/ld/configure.host
--- a/ld/configure.host	2013-11-04 19:33:39.000000000 +0400
+++ b/ld/configure.host	2022-02-17 13:57:25.734410500 +0300
@@ -191,6 +191,10 @@
   HOSTING_LIBS='-L/usr/lib32 '"$HOSTING_LIBS"' `if [ -f ../gcc/crtend.o ]; then echo ../gcc/crtend.o ; else ${CC} -print-file-name=crtend.o; fi` /usr/lib32/crtn.o -init __do_global_ctors -fini __do_global_dtors'
   ;;
 
+m68*-*-amigaos*)
+  HDEFINES=-mstackextend
+  ;;
+
 m68*-motorola-sysv)
   HOSTING_CRT0='`if [ -f ../gcc/crt0.o ]; then echo ../gcc/crt0.o; elif [ -f \`${CC} -print-file-name=\`crt0.o ]; then echo \`${CC} -print-file-name=\`crt0.o; else echo /lib/crt0.o; fi`'
   HOSTING_LIBS=`sed -e 's,-lc,-lc881,' <<EOF
diff -ru --new-file a/ld/configure.tgt b/ld/configure.tgt
--- a/ld/configure.tgt	2013-11-26 15:37:33.000000000 +0400
+++ b/ld/configure.tgt	2022-02-17 13:59:00.927964900 +0300
@@ -329,6 +329,7 @@
 			targ_extra_ofiles="deffilep.o pep-dll.o pe-dll.o" ;;
 i[3-7]86-*-interix*)	targ_emul=i386pe_posix;
  			targ_extra_ofiles="deffilep.o pe-dll.o" ;;
+i[3-7]86be-*-amithlon*) targ_emul=amithlon;;
 i[3-7]86-*-beospe*)	targ_emul=i386beos ;;
 i[3-7]86-*-beos*)	targ_emul=elf_i386_be ;;
 i[3-7]86-*-vxworks*)	targ_emul=elf_i386_vxworks ;;
@@ -393,6 +394,7 @@
 m68k-sony-*)		targ_emul=news ;;
 m68k-hp-bsd*)		targ_emul=hp300bsd ;;
 m68*-motorola-sysv*)	targ_emul=delta68 ;;
+m68*-*-amigaos*)	targ_emul=amiga ; targ_extra_emuls=amiga_bss;;
 m68*-*-aout)		targ_emul=m68kaout ;;
 m68*-*-coff)		targ_emul=m68kcoff ;;
 m68*-*-elf)		targ_emul=m68kelf ;;
@@ -529,6 +531,9 @@
 pjl*-*-*)	        targ_emul=pjlelf ; targ_extra_emuls="elf_i386" ;;
 pj*-*-*)	        targ_emul=pjelf
 			;;
+powerpc-*-amigaos*)	targ_emul=amigaos; targ_extra_emuls=elf32ppc ;;
+powerpc-*-amigaoshunk*)	targ_emul=ppcamiga ; targ_extra_emuls=ppcamiga_bss;;
+powerpc-*-morphos*)	targ_emul=morphos ; targ_extra_emuls=morphos_baserel;;
 powerpc-*-freebsd* | powerpc-*-kfreebsd*-gnu)
 			targ_emul=elf32ppc_fbsd
 			targ_extra_emuls="elf32ppc elf32ppcsim"
@@ -819,6 +824,10 @@
 *-*-netbsd*)
   ;;
 
+powerpc-*-amigaos*)
+  NATIVE_LIB_DIRS='/gcc/local/lib /gcc/lib'
+  ;;
+
 alpha*-*-*)
   NATIVE_LIB_DIRS='/usr/local/lib /usr/ccs/lib /lib /usr/lib'
   ;;
diff -ru --new-file a/ld/emulparams/amiga.sh b/ld/emulparams/amiga.sh
--- a/ld/emulparams/amiga.sh	1970-01-01 03:00:00.000000000 +0300
+++ b/ld/emulparams/amiga.sh	2021-02-01 23:12:49.271811900 +0300
@@ -0,0 +1,6 @@
+SCRIPT_NAME=amiga
+OUTPUT_FORMAT="amiga"
+TEXT_START_ADDR=0x0
+SEGMENT_SIZE=0x0
+TEMPLATE_NAME=amiga
+ARCH=m68k
diff -ru --new-file a/ld/emulparams/amiga_bss.sh b/ld/emulparams/amiga_bss.sh
--- a/ld/emulparams/amiga_bss.sh	1970-01-01 03:00:00.000000000 +0300
+++ b/ld/emulparams/amiga_bss.sh	2021-02-01 23:12:49.271811900 +0300
@@ -0,0 +1,6 @@
+SCRIPT_NAME=amiga_bss
+OUTPUT_FORMAT="amiga"
+TEXT_START_ADDR=0x0
+SEGMENT_SIZE=0x0
+TEMPLATE_NAME=amiga
+ARCH=m68k
diff -ru --new-file a/ld/emulparams/amigaos.sh b/ld/emulparams/amigaos.sh
--- a/ld/emulparams/amigaos.sh	1970-01-01 03:00:00.000000000 +0300
+++ b/ld/emulparams/amigaos.sh	2022-02-17 18:55:07.182603900 +0300
@@ -0,0 +1,26 @@
+#. ${srcdir}/emulparams/elf32ppccommon.sh
+TEMPLATE_NAME=amigaos
+SCRIPT_NAME=amigaos
+OUTPUT_FORMAT="elf32-amigaos"
+MAXPAGESIZE="CONSTANT (MAXPAGESIZE)"
+COMMONPAGESIZE="CONSTANT (COMMONPAGESIZE)"
+ALIGNMENT=16
+ARCH=powerpc
+MACHINE=
+GENERATE_SHLIB_SCRIPT=yes
+TEXT_START_ADDR=0x01000000
+SHLIB_TEXT_START_ADDR=0x10000000
+unset WRITABLE_RODATA
+DATA_START_SYMBOLS="_DATA_BASE_ = .;"
+SDATA_START_SYMBOLS="_SDA_BASE_ = . + 0x8000;"
+DATA_GOT=
+SDATA_GOT=
+TEXT_PLT=yes
+SEPARATE_GOTPLT=0
+unset BSS_PLT
+unset DATA_PLT
+GOT=".got          ${RELOCATING-0} : SPECIAL { *(.got) }"
+PLT=".plt          ${RELOCATING-0} :  { *(.plt) }"
+# GOTPLT="${PLT}"
+OTHER_TEXT_SECTIONS="*(.glink)"
+EXTRA_EM_FILE=ppc32elf
diff -ru --new-file a/ld/emulparams/amithlon.sh b/ld/emulparams/amithlon.sh
--- a/ld/emulparams/amithlon.sh	1970-01-01 03:00:00.000000000 +0300
+++ b/ld/emulparams/amithlon.sh	2021-02-01 23:12:49.274817900 +0300
@@ -0,0 +1,11 @@
+SCRIPT_NAME=amithlon
+OUTPUT_FORMAT="elf32-i386be-amithlon"
+#TEXT_START_ADDR=0x08048000
+#MAXPAGESIZE=0x1000
+MAXPAGESIZE=32
+#NONPAGED_TEXT_START_ADDR=0x08048000
+ARCH=i386
+MACHINE=
+NOP=0x9090
+TEMPLATE_NAME=amithlon
+GENERATE_SHLIB_SCRIPT=yes
diff -ru --new-file a/ld/emulparams/morphos.sh b/ld/emulparams/morphos.sh
--- a/ld/emulparams/morphos.sh	1970-01-01 03:00:00.000000000 +0300
+++ b/ld/emulparams/morphos.sh	2021-02-01 23:12:49.274817900 +0300
@@ -0,0 +1,6 @@
+TEMPLATE_NAME=morphos
+SCRIPT_NAME=morphos
+OUTPUT_FORMAT="elf32-morphos"
+MAXPAGESIZE=0x40000
+ARCH=powerpc
+MACHINE=
diff -ru --new-file a/ld/emulparams/morphos_baserel.sh b/ld/emulparams/morphos_baserel.sh
--- a/ld/emulparams/morphos_baserel.sh	1970-01-01 03:00:00.000000000 +0300
+++ b/ld/emulparams/morphos_baserel.sh	2021-02-01 23:12:49.275823000 +0300
@@ -0,0 +1,6 @@
+TEMPLATE_NAME=morphos
+SCRIPT_NAME=morphos_baserel
+OUTPUT_FORMAT="elf32-morphos"
+MAXPAGESIZE=0x40000
+ARCH=powerpc
+MACHINE=
diff -ru --new-file a/ld/emulparams/ppcamiga.sh b/ld/emulparams/ppcamiga.sh
--- a/ld/emulparams/ppcamiga.sh	1970-01-01 03:00:00.000000000 +0300
+++ b/ld/emulparams/ppcamiga.sh	2021-02-01 23:12:49.276824000 +0300
@@ -0,0 +1,8 @@
+SCRIPT_NAME=amiga
+OUTPUT_FORMAT="amiga"
+TEXT_START_ADDR=0x400
+PAGE_SIZE=0x400
+SEGMENT_SIZE=0x400
+NONPAGED_TEXT_START_ADDR=0x400
+TEMPLATE_NAME=amiga
+ARCH=powerpc
diff -ru --new-file a/ld/emulparams/ppcamiga_bss.sh b/ld/emulparams/ppcamiga_bss.sh
--- a/ld/emulparams/ppcamiga_bss.sh	1970-01-01 03:00:00.000000000 +0300
+++ b/ld/emulparams/ppcamiga_bss.sh	2021-02-01 23:12:49.277825300 +0300
@@ -0,0 +1,8 @@
+SCRIPT_NAME=amiga_bss
+OUTPUT_FORMAT="amiga"
+TEXT_START_ADDR=0x400
+PAGE_SIZE=0x400
+SEGMENT_SIZE=0x400
+NONPAGED_TEXT_START_ADDR=0x400
+TEMPLATE_NAME=amiga
+ARCH=powerpc
diff -ru --new-file a/ld/emultempl/ppc32elf.em b/ld/emultempl/ppc32elf.em
--- a/ld/emultempl/ppc32elf.em	2013-11-04 19:33:39.000000000 +0400
+++ b/ld/emultempl/ppc32elf.em	2022-02-17 14:02:30.750937600 +0300
@@ -29,6 +29,9 @@
 #include "elf32-ppc.h"
 #include "ldlex.h"
 
+extern int ppc_elf_amigaos_select_plt_layout (bfd *, struct bfd_link_info *,
+    enum ppc_elf_plt_type, int);
+
 #define is_ppc_elf(bfd) \
   (bfd_get_flavour (bfd) == bfd_target_elf_flavour \
    && elf_object_id (bfd) == PPC32_ELF_DATA)
@@ -59,8 +62,13 @@
 
       if (emit_stub_syms < 0)
 	emit_stub_syms = link_info.emitrelocations || link_info.shared;
+#ifdef TARGET_IS_amigaos
+      new_plt = ppc_elf_amigaos_select_plt_layout (link_info.output_bfd, &link_info,
+					   plt_style, emit_stub_syms);
+#else
       new_plt = ppc_elf_select_plt_layout (link_info.output_bfd, &link_info,
 					   plt_style, emit_stub_syms);
+#endif
       if (new_plt < 0)
 	einfo ("%X%P: select_plt_layout problem %E\n");
 
@@ -187,6 +195,9 @@
 #define OPTION_STUBSYMS			(OPTION_OLD_GOT + 1)
 #define OPTION_NO_STUBSYMS		(OPTION_STUBSYMS + 1)
 '
+#
+# CHECK: There was more here about use-dynld option.
+#
 
 PARSE_AND_LIST_LONGOPTS=${PARSE_AND_LIST_LONGOPTS}'
   { "emit-stub-syms", no_argument, NULL, OPTION_STUBSYMS },
diff -ru --new-file a/ld/ldctor.c b/ld/ldctor.c
--- a/ld/ldctor.c	2013-11-04 19:33:39.000000000 +0400
+++ b/ld/ldctor.c	2022-02-17 14:07:09.287287900 +0300
@@ -259,8 +259,12 @@
       /* If the symbol is defined, we may have been invoked from
 	 collect, and the sets may already have been built, so we do
 	 not do anything.  */
-      if (p->h->type == bfd_link_hash_defined
-	  || p->h->type == bfd_link_hash_defweak)
+      /* dgv -- libnix v1.1 uses absolute sets that are also explicitly
+	 defined in the library so that the sets need to be build even
+	 if the symbol is defined */
+      if ((bfd_get_flavour (link_info.output_bfd) != bfd_target_amiga_flavour) &&
+	  (p->h->type == bfd_link_hash_defined
+	  || p->h->type == bfd_link_hash_defweak))
 	continue;
 
       /* For each set we build:
@@ -356,15 +360,21 @@
 
 	      if (e->name != NULL)
 		minfo ("%T\n", e->name);
-	      else
+	      else if (e->section->owner)
 		minfo ("%G\n", e->section->owner, e->section, e->value);
+	      else
+		minfo ("%s\n", "** ABS **");
 	    }
 
 	  /* Need SEC_KEEP for --gc-sections.  */
 	  if (! bfd_is_abs_section (e->section))
 	    e->section->flags |= SEC_KEEP;
 
-	  if (link_info.relocatable)
+	  /* dgv -- on the amiga, we want the constructors to be relocateable
+	     objects. However, this should be arranged somewhere else (FIXME) */
+	  if (link_info.relocatable ||
+	      (bfd_get_flavour (link_info.output_bfd) == bfd_target_amiga_flavour &&
+	       e->section != bfd_abs_section_ptr))
 	    lang_add_reloc (p->reloc, howto, e->section, e->name,
 			    exp_intop (e->value));
 	  else
diff -ru --new-file a/ld/ldfile.c b/ld/ldfile.c
--- a/ld/ldfile.c	2013-11-04 19:33:39.000000000 +0400
+++ b/ld/ldfile.c	2022-02-17 14:10:00.694936300 +0300
@@ -66,6 +66,40 @@
 static search_arch_type *search_arch_head;
 static search_arch_type **search_arch_tail_ptr = &search_arch_head;
 
+/* Flavour support.  */
+
+static int flavors_cmp PARAMS ((const void *f1, const void *f2));
+
+static int n_flavors, flavors_len;
+static char **flavors;
+
+static int
+flavors_cmp (f1, f2)
+     const void *f1, *f2;
+{
+  return strcmp (*(char **)f1, *(char **)f2);
+}
+
+void
+ldfile_sort_flavors ()
+{
+  if (n_flavors > 1)
+    qsort ((void *) flavors, n_flavors, sizeof (char **), flavors_cmp);
+}
+
+void
+ldfile_add_flavor (name)
+     const char *name;
+{
+  n_flavors++;
+  if (flavors)
+    flavors = (char **) xrealloc ((PTR)flavors, n_flavors * sizeof (char *));
+  else
+    flavors = (char **) xmalloc (sizeof (char *));
+  flavors [n_flavors-1] = (char *) name;
+  flavors_len += strlen (name);
+}
+
 /* Test whether a pathname, after canonicalization, is the same or a
    sub-directory of the sysroot directory.  */
 
@@ -335,6 +369,7 @@
 			 const char *lib,
 			 const char *suffix)
 {
+  char *flavor_dir = (char *) alloca (flavors_len + n_flavors + 1);
   search_dirs_type *search;
 
   /* If this is not an archive, try to open it in the current
@@ -362,18 +397,31 @@
   for (search = search_head; search != NULL; search = search->next)
     {
       char *string;
-
+      int i, count;
+	  
       if (entry->flags.dynamic && ! link_info.relocatable)
 	{
 	  if (ldemul_open_dynamic_archive (arch, search, entry))
 	    return TRUE;
 	}
 
+  /* This is intentionally indented so strange to aid merging */
+  for (count=n_flavors; count>=0; count--)
+    {
+      *flavor_dir = '\0';
+      for (i=0; i<count; i++)
+	{
+	  strcat (flavor_dir, flavors[i]);
+	  strcat (flavor_dir, slash);
+	}
+
       if (entry->flags.maybe_archive)
-	string = concat (search->name, slash, lib, entry->filename,
+	string = concat (search->name, slash, flavor_dir, lib, entry->filename,
 			 arch, suffix, (const char *) NULL);
+      else if (entry->filename[0] == '/' || entry->filename[0] == '.')
+	string = concat(entry->filename, NULL);
       else
-	string = concat (search->name, slash, entry->filename,
+	string = concat (search->name, slash, flavor_dir, entry->filename,
 			 (const char *) 0);
 
       if (ldfile_try_open_bfd (string, entry))
@@ -385,6 +433,7 @@
       free (string);
     }
 
+	}
   return FALSE;
 }
 
diff -ru --new-file a/ld/ldfile.h b/ld/ldfile.h
--- a/ld/ldfile.h	2013-11-04 19:33:39.000000000 +0400
+++ b/ld/ldfile.h	2022-02-17 14:10:29.319543100 +0300
@@ -58,5 +58,9 @@
 extern bfd_boolean ldfile_open_file_search
   (const char *arch, struct lang_input_statement_struct *,
    const char *lib, const char *suffix);
+extern void ldfile_sort_flavors
+  PARAMS ((void));
+extern void ldfile_add_flavor
+  PARAMS ((const char *));
 
 #endif
diff -ru --new-file a/ld/ldlang.c b/ld/ldlang.c
--- a/ld/ldlang.c	2013-11-04 19:33:39.000000000 +0400
+++ b/ld/ldlang.c	2022-02-17 14:11:06.737219000 +0300
@@ -3392,6 +3392,13 @@
 void
 ldlang_add_undef (const char *const name, bfd_boolean cmdline)
 {
+#if 1
+  /* This is a quick ugly hak of getting around the problem
+   * with -use-dynld being passed to the linker
+   */
+  if (strcmp(name, "se-dynld") == 0)
+    return;
+#endif
   ldlang_undef_chain_list_type *new_undef;
 
   undef_from_cmdline = undef_from_cmdline || cmdline;
